/* macros de caracter general */
#define TRUE  (char)1
#define FALSE (char)0
#define MAX(a,b) (((a) > (b)) ? (a) : (b))
#define MIN(a,b) (((a) < (b)) ? (a) : (b))

#define ALLOC(n,type) (type *)malloc((n)*sizeof(type))
#define REALLOC(ptr,n,type) (type *)realloc(((char *)ptr),(n)*sizeof(type))
#define FREE(p) if (p) {free(p); (p)= NULL;}

#define TRY_ALLOC(ptr,n,type) if (!(ptr= ALLOC((n),type))) \
                                    {iexit= -50; return;}
#define TRY_REALLOC(ptr,n,type) if (!(ptr= REALLOC((ptr),(n),type))) \
                                    {iexit= -50; return;}

#define COMPROVAR_IEXIT if (iexit) {*iexit_= iexit; \
				    ip_write_iexit(); \
				    ip_free_memoria(); \
				    return;}

#define COMPROVAR_IEXIT_RESTAURA if (iexit) {*iexit_= iexit; \
					     ip_write_iexit();\
					     ip_restaura_dades();\
					     ip_free_memoria();\
				             return;}

#define COMPROVAR_IEXIT_BREAK if (iexit) break

#define BLOCKSIZE 10000

#define PCT_FILL_IN_SUPOSAT ((double)0.10)


/* constants numeriques */
#define EPSIL_X0 ((double)1.0e-1)
#define X0 ((double)100.0)
#define X0_FCB ((double)100.0)
#define EPS_DIR epsmach

/* constants predefinides. en un futur a ser opcions del programa  */
#define SIGMA ((double)0.1)
#define RHO ((double)0.995)
#define OPTIM_GAP ((double)1.0e-5)
#define OPTIM_PFEAS ((double)1.0e-6)
#define OPTIM_DFEAS ((double)1.0e-6)
#define OUTPUT_FREQ 1
#define MAXITER 200
#define EPS_PINF ((double)1.0e-3)
#define EPS_DINF ((double)1.0e-3)
#define EPS_CG ((double)1.0e-2)
#define MAXCMT (300)
#define PCT_MAXCMT (0.6)
#define OPTIM_GAP_SAFEGUARD ((double)1.0e-5)



